FROM python:3.7-slim as base

RUN apt-get update -qq \
  && apt-get install -y --no-install-recommends \
  tk-dev \
  # required by psycopg2 at build and runtime
  libpq-dev \
  # required for health check
  curl \
  && apt-get autoremove -y

FROM base as builder

RUN apt-get update -qq && \
  apt-get install -y --no-install-recommends \
  build-essential \
  wget \
  openssh-client \
  graphviz-dev \
  pkg-config \
  git-core \
  openssl \
  libssl-dev \
  libffi6 \
  libffi-dev \
  libpng-dev

# install poetry
# keep this in sync with the version in pyproject.toml and Dockerfile
ENV POETRY_VERSION 1.0.5
RUN curl -sSL https://raw.githubusercontent.com/python-poetry/poetry/master/get-poetry.py | python
ENV PATH "/root/.poetry/bin:/opt/venv/bin:${PATH}"

# copy files
COPY ./rasa-for-cobat /build/

# change working directory
WORKDIR /build

# install dependencies
RUN python -m venv /opt/venv && \
  . /opt/venv/bin/activate && \
  pip install --no-cache-dir -U 'pip<20' && \
  poetry install --extras transformers --no-dev --no-root --no-interaction && \
  poetry build -f wheel -n && \
  python addons_setup.py bdist_wheel -d dist && \
  pip wheel -r addons_requirements.txt -w dist && \
  pip install --no-deps dist/*.whl && \
  rm -rf dist *.egg-info

# install denver dependencies
# RUN pip install -U --no-cache-dir -r nlu_requirements.txt

# start a new build stage
FROM base as runner

# copy everything from /opt
COPY --from=builder /opt/venv /opt/venv

# make sure we use the virtualenv
ENV PATH="/opt/venv/bin:$PATH"

# update permissions & change user to not run as root
WORKDIR /app
RUN chgrp -R 0 /app && chmod -R g=u /app
RUN mkdir -p /.allennlp
RUN chgrp -R 0 /.allennlp && chmod -R g=u /.allennlp
USER 1001 

# create a volume for temporary data
VOLUME /tmp

# change shell
SHELL ["/bin/bash", "-o", "pipefail", "-c"]

# the entry point
EXPOSE 5005
ENTRYPOINT ["rasa"]
